<script setup lang="ts">
    import { graphql } from "./../../gql/index";
    import { computed } from "vue";
    import useNavigationStore from "./../../stores/navigation";
    import { useQuery, useMutation } from "@vue/apollo-composable";

    const navigationStore = useNavigationStore();

    // current events
    const instructorQueryVariables = computed(() => {
        return {
            id: navigationStore.instructorId,
        };
    });
    const instructorEventsQuery = graphql(`
        query InstructorEventsQuery($id: Uuid = "00000000-0000-0000-0000-000000000000") {
            instructor(id: $id) {
                id
                extensions {
                    id
                    event {
                        id
                    }
                }
            }
        }
    `);
    const { result: resultInstructorEvents } = useQuery(instructorEventsQuery, instructorQueryVariables, {
        fetchPolicy: "cache-and-network",
    });
    const currentEventIds = computed(() => {
        let extensions = resultInstructorEvents.value?.instructor!.extensions! ?? [];
        let res = [] as string[];

        extensions.forEach((extension) => {
            res.push(extension.event?.id);
        });

        return res;
    });

    // all events
    const eventsQuery = graphql(`
        query EventNamesAndIdsForInstructors {
            allEvents {
                id
                name
                year
                startDate
            }
        }
    `);
    const { result: eventsResult } = useQuery(eventsQuery, null, {
        fetchPolicy: "cache-and-network",
    });
    const events = computed(() => {
        let res = eventsResult.value?.allEvents! ?? [];

        let filtered = res.filter((event) => {
            return !currentEventIds.value.includes(event.id);
        });

        // more recent events are more to the top
        filtered.sort((a, b) => {
            return b.startDate.localeCompare(a.startDate);
        });

        return filtered;
    });

    // mutation
    const addingMutation = graphql(`
        mutation AddEventToInstructorMutation(
            $eventId: Uuid = "00000000-0000-0000-0000-000000000000"
            $instructorId: Uuid = "00000000-0000-0000-0000-000000000000"
        ) {
            createInstructorExtension(values: { instructorId: $instructorId, eventId: $eventId }) {
                id
                # Below stuff needs to be queried, so that the cache is updated!
                instructor {
                    id
                    extensions {
                        id
                    }
                }
            }
        }
    `);
    const { mutate: addToEvent } = useMutation(addingMutation, () => ({
        fetchPolicy: "network-only",
    }));

    async function addInstructorToEvent(id: string) {
        addToEvent({
            instructorId: navigationStore.instructorId,
            eventId: id,
        });

        navigationStore.instructorViewTab = id;
    }
</script>

<template>
    <template v-for="event in events" :key="event.id">
        <p class="py-2">
            <b>{{ event.name }} ({{ event.year }})</b>:
            <v-btn @click="addInstructorToEvent(event.id)" class="ml-5">
                <template v-slot:prepend> <span class="material-symbols-outlined"> add </span></template>
                Hinzufügen
            </v-btn>
        </p>
    </template>
    <p v-if="events.length == 0">Der Zirkelleiter ist bereits in allen verfügbaren Veranstaltungen eingetragen</p>
</template>
